/*
 *
 *   Created for Abducted IRC by Anomaly
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#include "proto.h"
#include "inet.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

DLLFUNC int m_operlogin(aClient *cptr, aClient *sptr, int parc, char *parv[]);

/* Place includes here */
#define MSG_OPERLOGIN        "OPERLOGIN"
#define TOK_OPERLOGIN        "ZM"

ModuleHeader MOD_HEADER(m_operlogin)
  = {
	"operlogin",	/* Name of module */
	"",
	"", /* Short description of module */
	"3.2-b8-1",
	NULL 
    };

DLLFUNC int MOD_INIT(m_operlogin)(ModuleInfo *modinfo)
{
	/*
	 * We call our add_Command crap here
	*/
	add_Command(MSG_OPERLOGIN, TOK_OPERLOGIN, m_operlogin, MAXPARA);
	return MOD_SUCCESS;
}

DLLFUNC int MOD_LOAD(m_operlogin)(int module_load)
{
	return MOD_SUCCESS;
}

DLLFUNC int MOD_UNLOAD(m_operlogin)(int module_unload)
{
	if (del_Command(MSG_OPERLOGIN, TOK_OPERLOGIN, m_operlogin) < 0)
	{
		sendto_realops("Failed to delete commands when unloading %s",
				MOD_HEADER(m_operlogin).name);
	}
	return MOD_SUCCESS;
}


/*
** m_operlogin
**	parv[0] = sender prefix
**	parv[1] = user name
*/

DLLFUNC int  m_operlogin(aClient *cptr, aClient *sptr, int parc, char *parv[]) {
	char *name, *operlogin;
	aClient *acptr;


	if (!IsServer(cptr))
		return 0;

	if (parc < 3) {
		sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		    me.name, parv[0], "STAFF");
		return 0;
	}

	name = parv[1];
	operlogin = parv[2];

	if (!(acptr = find_client(name,NULL)))
		return 0;

	if (sptr->user->operlogin)
		MyFree(sptr->user->operlogin);
	sptr->user->operlogin = strdup(operlogin);

	return 0;
}
