/*
 *
 *   Created for Abducted IRC by Anomaly
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#include "proto.h"
#include "inet.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

DLLFUNC int m_staff(aClient *cptr, aClient *sptr, int parc, char *parv[]);
DLLFUNC int m_uline(aClient *cptr, aClient *sptr, int parc, char *parv[]);

/* Place includes here */
#define MSG_STAFF        "STAFF"
#define TOK_STAFF        "ZY"
#define MSG_ULINE	 "ULINE"
#define TOK_ULINE	 "ZR"

ModuleHeader MOD_HEADER(m_staff)
  = {
	"staff",	/* Name of module */
	"",
	"", /* Short description of module */
	"3.2-b8-1",
	NULL 
    };

DLLFUNC int MOD_INIT(m_staff)(ModuleInfo *modinfo)
{
	/*
	 * We call our add_Command crap here
	*/
	add_Command(MSG_STAFF, TOK_STAFF, m_staff, MAXPARA);
	add_Command(MSG_ULINE, TOK_ULINE, m_uline, MAXPARA);
	return MOD_SUCCESS;
}

DLLFUNC int MOD_LOAD(m_staff)(int module_load)
{
	return MOD_SUCCESS;
}

DLLFUNC int MOD_UNLOAD(m_staff)(int module_unload)
{
	if ((del_Command(MSG_STAFF, TOK_STAFF, m_staff) < 0) &&
		(del_Command(MSG_ULINE, TOK_ULINE, m_uline) < 0))
	{
		sendto_realops("Failed to delete commands when unloading %s",
				MOD_HEADER(m_staff).name);
	}
	return MOD_SUCCESS;
}


/*
** m_staff
**	parv[0] = sender prefix
**	parv[1] = user name
*/

DLLFUNC int  m_staff(aClient *cptr, aClient *sptr, int parc, char *parv[]) {
	char *name;
	aClient *acptr;
	
	if (!IsULine(sptr) && !IsServer(sptr))
		return 0;

	if (parc < 2) {
		sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		    me.name, parv[0], "STAFF");
		return 0;
	}

	name = parv[1];

        if (!(acptr = find_client(name, NULL))) {
		sendto_one(sptr, err_str(ERR_NOSUCHNICK),
                                    me.name, parv[0], name);
		return 0;
	}

	acptr->flags |= FLAGS_STAFF;
	sendto_serv_butone_token(MyClient(cptr) ? &me : cptr,
		sptr->name, MSG_STAFF, TOK_STAFF,
		"%s", acptr->name);
	return 0;
}
DLLFUNC int  m_uline(aClient *cptr, aClient *sptr, int parc, char *parv[]) {
	char *name;
	aClient *acptr;	
	if (!IsULine(sptr) && !IsServer(sptr))
		return 0;

	if (parc < 2) {
		sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		    me.name, parv[0], "ULINE");
		return 0;
	}

	name = parv[1];

        if (!(acptr = find_client(name, NULL))) {
		sendto_one(sptr, err_str(ERR_NOSUCHNICK),
                                    me.name, parv[0], name);
		return 0;
	}

	acptr->flags |= FLAGS_ULINE;
	sendto_serv_butone_token(MyClient(cptr) ? &me : cptr,
		sptr->name, MSG_ULINE, TOK_ULINE,
		"%s", acptr->name);
	return 0;
}
